%define libname_orig libpng
%define major 14
%define libname	%mklibname png 14 %{major}
%define develname %mklibname png14 -d
%define staticname %mklibname png14 -d -s

%bcond_without	uclibc

Summary:	A library of functions for manipulating PNG image format files
Name:		libpng14
Version:	1.4.8
Release:	%mkrel 1
Epoch:		2
License:	zlib
Group:		System/Libraries
URL:		http://www.libpng.org/pub/png/libpng.html
Source:		http://prdownloads.sourceforge.net/libpng/libpng-%{version}.tar.xz
%if %{with uclibc}
BuildRequires: 	uClibc-zlib-devel
BuildRequires:	uClibc-devel
%else
BuildRequires: 	zlib-devel
%endif

%description
The libpng package contains a library of functions for creating and
manipulating PNG (Portable Network Graphics) image format files.  PNG is
a bit-mapped graphics format similar to the GIF format.  PNG was created to
replace the GIF format, since GIF uses a patented data compression
algorithm.

Libpng should be installed if you need to manipulate PNG format image
files.

%package -n	%{libname}
Summary:	A library of functions for manipulating PNG image format files
Group:		System/Libraries
Obsoletes:	%{_lib}png3 < 2:1.2.46-2

%description -n	%{libname}
This package contains the library needed to run programs dynamically
linked with libpng.

%package -n	%{develname}
Summary:	Development tools for programs to manipulate PNG image format files
Group:		Development/C
Requires:	%{libname} = %{epoch}:%{version}
Provides:	%{name}-devel = %{epoch}:%{version}-%{release}
Conflicts:	%{_lib}png-devel < 2:1.5.4

%description -n	%{develname}
The libpng-devel package contains the header files and libraries
necessary for developing programs using the PNG (Portable Network
Graphics) library.

If you want to develop programs which will manipulate PNG image format
files, you should install libpng-devel.  You'll also need to install the
libpng package.

%package -n	%{staticname}
Summary:	Development static libraries
Group:		Development/C
Requires:	%{develname} = %{epoch}:%{version}
Provides:	%{name}-static-devel = %{epoch}:%{version}-%{release}
Conflicts:	%{_lib}png-static-devel < 2:1.5.4

%description -n	%{staticname}
Libpng development static libraries.

%prep
%setup -qn libpng-%{version}
./autogen.sh

%build
export CONFIGURE_TOP=`pwd`
%if %{with uclibc}
mkdir -p uclibc
cd uclibc
%configure2_5x	CC="%{uclibc_cc}" \
		CFLAGS="%{uclibc_cflags}" \
		--enable-shared=no \
		--enable-static=yes \
		--with-pic
%make
cd ..
%endif

mkdir -p shared
cd shared
CFLAGS="%{optflags} -O3 -funroll-loops" \
%configure2_5x	--with-pic
%make
cd ..

%check
make -C shared check

%install
rm -rf %{buildroot}
%makeinstall_std -C shared
%if %{with uclibc}
install -m644 uclibc/.libs/libpng14.a -D %{buildroot}%{uclibc_root}%{_libdir}/libpng14.a
ln -s libpng14.a %{buildroot}%{uclibc_root}%{_libdir}/libpng.a
%endif

# remove unpackaged files
rm -rf %{buildroot}{%{_prefix}/man,%{_libdir}/lib*.la}
rm -f %{buildroot}%{_libdir}/libpng.*

# remove compat files, which is conflicts with libpng 1.5
rm -f %{buildroot}%{_libdir}/pkgconfig/libpng.pc
rm -f %{buildroot}%{_bindir}/libpng-config
rm -f %{buildroot}%{_includedir}/*.h
rm -f %{buildroot}%{_mandir}/*/*

#multiarch
%multiarch_binaries %{buildroot}%{_bindir}/libpng14-config

%clean
rm -rf %{buildroot}

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/%{name}.so.%{major}*

%files -n %{develname}
%defattr(-,root,root)
%doc *.txt example.c README TODO CHANGES
%{_bindir}/libpng14-config
%{multiarch_bindir}/libpng14-config
%{_includedir}/libpng14
%{_libdir}/libpng14.so
%{_libdir}/pkgconfig/libpng14.pc

%files -n %{staticname}
%defattr(-,root,root)
%{_libdir}/libpng*.a
%if %{with uclibc}
%{uclibc_root}%{_libdir}/libpng*.a
%endif

